SystemOrganization addCategory: #'Xpf-ExposingMorphs'!

AlignmentMorph subclass: #ListExample
	instanceVariableNames: 'collection listMorph selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!ListExample methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:53'!
collection

	<bindableAsCollection>
	^ self valueOfVariableNamed: #collection! !

!ListExample methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:53'!
collection: anObject

	<bindableAsCollection>
	self setVariableNamed: #collection toValue: anObject! !

!ListExample methodsFor: 'initialization' stamp: 'topa 1/18/2010 18:47'!
initialize
	super initialize.
	
	"set default values"
	self collection: (OrderedCollection with: 'test1' with: 'test2' with: 'test3').
	self selected: self collection first.
		
	"initialize list morph"
	self listMorph: (SelectableListMorph new hResizing: #spaceFill).
	self listMorph 
		bind: #list to: self with: #collection;
		bind: #selection to: self with: #selected.
	
	"initialize graphical representation"
	self
		layoutInset: 0;
		wrapCentering: #center;
		cellPositioning: #leftCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 400@200.
		
	self addMorphBack: self listMorph.
! !

!ListExample methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:31'!
listMorph

	^ listMorph! !

!ListExample methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:31'!
listMorph: anObject

	listMorph := anObject! !

!ListExample methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:46'!
selected

	<bindable>
	^ self valueOfVariableNamed: #selected! !

!ListExample methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:44'!
selected: anObject

	<bindable>
	self setVariableNamed: #selected toValue: anObject! !

AlignmentMorph subclass: #ListExample2
	instanceVariableNames: 'collection collection2 selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!ListExample2 methodsFor: 'accessing' stamp: 'topa 1/18/2010 19:00'!
collection

	<bindableAsCollection>
	^ self valueOfVariableNamed: #collection! !

!ListExample2 methodsFor: 'accessing' stamp: 'topa 1/18/2010 19:18'!
collection2

	<bindableAsCollection>
	^ self valueOfVariableNamed: #collection2! !

!ListExample2 methodsFor: 'accessing' stamp: 'topa 1/18/2010 19:18'!
collection2: anObject

	<bindableAsCollection>
	self setVariableNamed: #collection2 toValue: anObject! !

!ListExample2 methodsFor: 'accessing' stamp: 'topa 1/18/2010 19:00'!
collection: anObject

	<bindableAsCollection>
	self setVariableNamed: #collection toValue: anObject! !

!ListExample2 methodsFor: 'initialization' stamp: 'topa 1/18/2010 21:48'!
initialize
	super initialize.
	
	"set default values"
	self collection: (OrderedCollection with: 'test1' with: 'test2' with: 'test3').
	self selected: self collection last.
		
	"initialize list morph"
	self 
		addMorphBack: (SelectableListMorph new
			bind: #list to: self with: #collection;
			bind: #selection to: self with: #selected);
		addMorphBack: (SelectableListMorph new
			bind: #list to: self with: #collection2).
	
	"initialize graphical representation"
	self extent: 300@120.! !

!ListExample2 methodsFor: 'accessing' stamp: 'topa 1/18/2010 19:00'!
selected

	<bindable>
	^ self valueOfVariableNamed: #selected! !

!ListExample2 methodsFor: 'accessing' stamp: 'topa 1/18/2010 19:19'!
selected: anObject

	<bindable>
	self setVariableNamed: #selected toValue: anObject.
	self collection2: (self selected asOrderedCollection collect: [:c | c asString]).! !

AlignmentMorph subclass: #ListExampleTraditional
	instanceVariableNames: 'collection list selectedIndex selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!ListExampleTraditional methodsFor: 'accessing' stamp: 'AK 1/17/2010 19:24'!
collection
	<bindableAsCollection>
	
	^ collection! !

!ListExampleTraditional methodsFor: 'accessing' stamp: 'AK 1/17/2010 19:24'!
collection: anObject
	<bindableAsCollection>
	
	collection := anObject! !

!ListExampleTraditional methodsFor: 'initialization' stamp: 'topa 1/18/2010 21:49'!
initialize
	super initialize.
	
	"set default values"
	self collection: (OrderedCollection with: 'test1' with: 'test2' with: 'test3').
	self selectedIndex: self collection size.
	
	"initialize list morph"
	self addMorphBack: (PluggableListMorph
		on: self
		list: #collection
		selected: #selectedIndex
		changeSelected: #selectedIndex:).
		
	"initialize graphical representation"
	self extent: 300@120.
! !

!ListExampleTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:34'!
selected
	^ selected! !

!ListExampleTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:34'!
selected: anObject
	selected := anObject! !

!ListExampleTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:34'!
selectedIndex
	^ selectedIndex! !

!ListExampleTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 18:52'!
selectedIndex: anObject
	selectedIndex := anObject.
	self selected: (self collection at: anObject).
	self changed: #selectedIndex.! !

AlignmentMorph subclass: #ListExampleTraditional2
	instanceVariableNames: 'collection list selectedIndex selected selected2 selectedIndex2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:55'!
collection
	^ collection! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:55'!
collection: aCollection
	collection := aCollection! !

!ListExampleTraditional2 methodsFor: 'initialization' stamp: 'topa 1/18/2010 21:57'!
initialize
	super initialize.
	
	"set default values"
	self collection: (OrderedCollection with: 'test1' with: 'test2' with: 'test3').
	self selectedIndex: self collection size.
	
	"initialize list morph"
	self addMorphBack: (PluggableListMorph
		on: self
		list: #collection
		selected: #selectedIndex
		changeSelected: #selectedIndex:).
		
	"initialize graphical representation"
	self extent: 300@120.
! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:56'!
selected
	^ selected! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:58'!
selected2
	^ selected2! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:58'!
selected2: anObject
	selected2 := anObject! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:56'!
selected: anObject
	selected := anObject! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:56'!
selectedIndex
	^ selectedIndex! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:58'!
selectedIndex2
	^ selectedIndex2! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:58'!
selectedIndex2: anObject
	selectedIndex2 := anObject! !

!ListExampleTraditional2 methodsFor: 'as yet unclassified' stamp: 'topa 1/18/2010 21:57'!
selectedIndex: anObject
	selectedIndex := anObject! !

SimpleSliderMorph subclass: #ExposingSlider
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:24'!
maxVal
	<bindable>
	^ self valueOfVariableNamed: #maxVal! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:24'!
maxVal: anObject
	<bindable>
	self setVariableNamed: #maxVal toValue: anObject.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:20'!
minVal
	<bindable>
	^ self valueOfVariableNamed: #minVal! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:22'!
minVal: anObject
	<bindable>
	self setVariableNamed: #minVal toValue: anObject.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 09:39'!
val
      <bindable>
	^ self valueOfVariableNamed: #val.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 08:34'!
val: anVal
      <bindable>
	self setVariableNamed: #val toValue: anVal.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 09:40'!
value
	<bindable>
	^ self valueOfVariableNamed: #value.
! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:05'!
value: newValue
	<bindable>
	"Drive the slider position externally..."
	self setVariableNamed: #value toValue: (newValue min: 1.0 max: 0.0).
	self computeSlider! !
